<?php
// REPORT FUNCTIONS
//
// Copyright (c) 2008-2009 Nagios Enterprises, LLC.  All rights reserved.
//
// $Id: utils-reports.inc.php 340 2010-10-11 20:31:28Z egalstad $

//require_once(dirname(__FILE__).'/common.inc.php');

////////////////////////////////////////////////////////////////////////////////
// XML DATA
////////////////////////////////////////////////////////////////////////////////

function get_xml_logentries($args){
	$x=simplexml_load_string(get_logentries_xml_output($args));
	//print_r($x);
	return $x;
	}

function get_xml_statehistory($args){
	$x=simplexml_load_string(get_statehistory_xml_output($args));
	//print_r($x);
	return $x;
	}

function get_xml_topalertproducers($args){
	$x=simplexml_load_string(get_topalertproducers_xml_output($args));
	//print_r($x);
	return $x;
	}

function get_xml_histogram($args){
	$x=simplexml_load_string(get_histogram_xml_output($args));
	//print_r($x);
	return $x;
	}
	
function get_xml_notificationswithcontacts($args){
	$x=simplexml_load_string(get_notificationswithcontacts_xml_output($args));
	//print_r($x);
	return $x;
	}

function get_xml_notifications($args){
	$x=simplexml_load_string(get_notifications_xml_output($args));
	//print_r($x);
	return $x;
	}
	

////////////////////////////////////////////////////////////////////////////////
// TIME CALCULATION FUNCTIONS
////////////////////////////////////////////////////////////////////////////////

function get_report_timeperiod_options(){

	$arr=array(
		"today" => "Today",
		"last24hours" => "Last 24 Hours",
		"yesterday" => "Yesterday",
		"thisweek" => "This Week",
		"thismonth" => "This Month",
		"thisquarter" => "This Quarter",
		"thisyear" => "This Year",
		"lastweek" => "Last Week",
		"lastmonth" => "Last Month",
		"lastquarter" => "Last Quarter",
		"lastyear" => "Last Year",
		"custom" => "Custom",
		);

	return $arr;
	}
	
	
function get_times_from_report_timeperiod($tp,&$start,&$end,$datestart="",$dateend=""){

	$now=time();

	// initial values
	$start=0;
	$end=0;
	
	switch($tp){
	
		case "today":
			$start=strtotime("midnight");
			$end=$now;
			break;
		case "last24hours":
			$start=strtotime("24 hours ago");
			$end=$now;
			break;
		case "yesterday":
			$start=strtotime("yesterday");
			$end=strtotime("midnight");
			break;
		case "thisweek":
			//$start=strtotime("first day of this week");
			$start=strtotime("last sunday");
			$end=$now;
			break;
		case "thismonth":
			//$start=strtotime("first day of this month");
			//$start=strtotime("day 1");
			$start=mktime(0,0,0,date("n"),1,date("Y"));
			$end=$now;
			break;
		case "thisquarter":
			$current_month=date("n");
			$current_year=date("Y");
			for($x=$current_month,$y=0;$y<=4;$x--,$y++){
				// cover december rollbacks
				if($x==0){
					$x=12;
					$current_year--;
					}
				if((($x-1)%3)==0)
					break;
				}
			$start=mktime(0,0,0,$x,1,$current_year);
			$end=$now;
			break;
		case "thisyear":
			$start=strtotime("January 1");
			$end=$now;
			break;
			
		case "lastweek":
			//$start=strtotime("first day of last week");
			//$end=strtotime("first day of this week");
			$start=strtotime("last sunday -7 days");
			$end=strtotime("last sunday");
			break;
		case "lastmonth":
			//$start=strtotime("first day of last month");
			//$end=strtotime("first day of this month");
			$start=mktime(0,0,0,date("n")-1,1,date("Y"));
			$end=mktime(0,0,0,date("n"),1,date("Y"));
			break;
		case "lastquarter":
			$current_month=date("n");
			$current_year=date("Y");
			$quarters=0;
			$q_end_month=1;
			$q_end_year=$current_year;
			for($x=$current_month,$y=0;$y<=7;$x--,$y++){
				// cover december rollbacks
				if($x==0){
					$x=12;
					$current_year--;
					}
				if((($x-1)%3)==0){
					$quarters++;
					if($quarters==1){
						$q_end_month=$x;
						$q_end_year=$current_year;
						}
					if($quarters>1)
						break;
					}
				}
			$start=mktime(0,0,0,$x,1,$current_year);
			$end=mktime(0,0,0,$q_end_month,1,$q_end_year);
			break;
		case "lastyear":
			//$start=strtotime("first day of last year");
			//$end=strtotime("first day of this week");
			$start=mktime(0,0,0,1,1,date("Y")-1);
			$end=mktime(0,0,0,1,1,date("Y"));
			break;
			
		case "custom":
			// custom dates passed to us
			$start=strtotime($datestart);
			$end=strtotime($dateend);
			
			//echo "START1=$start, END1=$end<BR>";
			
			// handle unix timestamps
			//if($start===false && is_int($datestart))
			if($start===false)
				$start=intval($datestart);
			//if($end===false && is_int($dateend))
			if($end===false)
				$end=intval($dateend);
			//echo "START2=$start, END2=$end<BR>";
			break;
		default:
			break;
		}
		
	// fix wierd values
	if($end>$now)
		$end=now;
	if($start>$end){
		if($end==0)
			$end=$start;
		else
			$start=$end;
		}
	//echo "START3=$start, END3=$end<BR>";
	}


////////////////////////////////////////////////////////////////////////////////
// MISC FUNCTIONS
////////////////////////////////////////////////////////////////////////////////

function state_type_to_string($state_type){
	$output="?";
	switch($state_type){
		case 0:
			$output="SOFT";
			break;
		case 1:
			$output="HARD";
			break;
		default:
			break;
		}
	return $output;
	}

function service_state_to_string($state,$assumeok=true){
	$output="? (".$state.")";
	switch($state){
		case 0:
			$output="OK";
			break;
		case 1:
			$output="WARNING";
			break;
		case 2:
			$output="CRITICAL";
			break;
		case 3:
			$output="UNKNOWN";
			break;
		case -1:
			if($assumeok==true)
				$output="OK";
			break;
		default:
			break;
		}
	return $output;
	}
	

function host_state_to_string($state,$assumeup=true){
	$output="? (".$state.")";
	switch($state){
		case 0:
			$output="UP";
			break;
		case 1:
			$output="DOWN";
			break;
		case 2:
			$output="UNREACHABLE";
			break;
		case -1:
			if($assumeup==true)
				$output="UP";
			break;
		default:
			break;
		}
	return $output;
	}
?>